/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Link to an application package inside the batch account
  *
 */
class ApplicationPackageReference {
  /**
   * Create a ApplicationPackageReference.
   * @property {string} id The ID of the application package to install. This
   * must be inside the same batch account as the pool. This can either be a
   * reference to a specific version or the default version if one exists.
   * @property {string} [version] The version of the application to deploy. If
   * omitted, the default version is deployed. If this is omitted, and no
   * default version is specified for this application, the request fails with
   * the error code InvalidApplicationPackageReferences. If you are calling the
   * REST API directly, the HTTP status code is 409.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationPackageReference
   *
   * @returns {object} metadata of ApplicationPackageReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationPackageReference',
      type: {
        name: 'Composite',
        className: 'ApplicationPackageReference',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationPackageReference;
