/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary An error that occurred when autoscaling a pool.
  *
 */
class AutoScaleRunError {
  /**
   * Create a AutoScaleRunError.
   * @property {string} code An identifier for the error. Codes are invariant
   * and are intended to be consumed programmatically.
   * @property {string} message A message describing the error, intended to be
   * suitable for display in a user interface.
   * @property {array} [details] Additional details about the error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutoScaleRunError
   *
   * @returns {object} metadata of AutoScaleRunError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoScaleRunError',
      type: {
        name: 'Composite',
        className: 'AutoScaleRunError',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AutoScaleRunErrorElementType',
                  type: {
                    name: 'Composite',
                    className: 'AutoScaleRunError'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AutoScaleRunError;
