/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary AutoScale settings for the pool.
  *
 */
class AutoScaleSettings {
  /**
   * Create a AutoScaleSettings.
   * @property {string} formula A formula for the desired number of compute
   * nodes in the pool.
   * @property {moment.duration} [evaluationInterval] The time interval at
   * which to automatically adjust the pool size according to the autoscale
   * formula. If omitted, the default value is 15 minutes (PT15M).
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutoScaleSettings
   *
   * @returns {object} metadata of AutoScaleSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutoScaleSettings',
      type: {
        name: 'Composite',
        className: 'AutoScaleSettings',
        modelProperties: {
          formula: {
            required: true,
            serializedName: 'formula',
            type: {
              name: 'String'
            }
          },
          evaluationInterval: {
            required: false,
            serializedName: 'evaluationInterval',
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = AutoScaleSettings;
