/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information used to connect to an Azure Storage Container using
 * Blobfuse.
  *
 */
class AzureBlobFileSystemConfiguration {
  /**
   * Create a AzureBlobFileSystemConfiguration.
   * @property {string} accountName The Azure Storage Account name.
   * @property {string} containerName The Azure Blob Storage Container name.
   * @property {string} [accountKey] The Azure Storage Account key. This
   * property is mutually exclusive with sasKey and one must be specified.
   * @property {string} [sasKey] The Azure Storage SAS token. This property is
   * mutually exclusive with accountKey and one must be specified.
   * @property {string} [blobfuseOptions] Additional command line options to
   * pass to the mount command. These are 'net use' options in Windows and
   * 'mount' options in Linux.
   * @property {string} relativeMountPath The relative path on the compute node
   * where the file system will be mounted. All file systems are mounted
   * relative to the Batch mounts directory, accessible via the
   * AZ_BATCH_NODE_MOUNTS_DIR environment variable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureBlobFileSystemConfiguration
   *
   * @returns {object} metadata of AzureBlobFileSystemConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBlobFileSystemConfiguration',
      type: {
        name: 'Composite',
        className: 'AzureBlobFileSystemConfiguration',
        modelProperties: {
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: true,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          accountKey: {
            required: false,
            serializedName: 'accountKey',
            type: {
              name: 'String'
            }
          },
          sasKey: {
            required: false,
            serializedName: 'sasKey',
            type: {
              name: 'String'
            }
          },
          blobfuseOptions: {
            required: false,
            serializedName: 'blobfuseOptions',
            type: {
              name: 'String'
            }
          },
          relativeMountPath: {
            required: true,
            serializedName: 'relativeMountPath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBlobFileSystemConfiguration;
