/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information used to connect to an Azure Fileshare.
  *
 */
class AzureFileShareConfiguration {
  /**
   * Create a AzureFileShareConfiguration.
   * @property {string} accountName The Azure Storage account name.
   * @property {string} azureFileUrl The Azure Files URL. This is of the form
   * 'https://{account}.file.core.windows.net/'.
   * @property {string} accountKey The Azure Storage account key.
   * @property {string} relativeMountPath The relative path on the compute node
   * where the file system will be mounted. All file systems are mounted
   * relative to the Batch mounts directory, accessible via the
   * AZ_BATCH_NODE_MOUNTS_DIR environment variable.
   * @property {string} [mountOptions] Additional command line options to pass
   * to the mount command. These are 'net use' options in Windows and 'mount'
   * options in Linux.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureFileShareConfiguration
   *
   * @returns {object} metadata of AzureFileShareConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFileShareConfiguration',
      type: {
        name: 'Composite',
        className: 'AzureFileShareConfiguration',
        modelProperties: {
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          azureFileUrl: {
            required: true,
            serializedName: 'azureFileUrl',
            type: {
              name: 'String'
            }
          },
          accountKey: {
            required: true,
            serializedName: 'accountKey',
            type: {
              name: 'String'
            }
          },
          relativeMountPath: {
            required: true,
            serializedName: 'relativeMountPath',
            type: {
              name: 'String'
            }
          },
          mountOptions: {
            required: false,
            serializedName: 'mountOptions',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFileShareConfiguration;
