/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters for updating an Azure Batch account.
 *
 */
class BatchAccountUpdateParameters {
  /**
   * Create a BatchAccountUpdateParameters.
   * @property {object} [tags] The user-specified tags associated with the
   * account.
   * @property {object} [autoStorage] The properties related to the
   * auto-storage account.
   * @property {string} [autoStorage.storageAccountId] The resource ID of the
   * storage account to be used for auto-storage account.
   * @property {object} [encryption] The encryption configuration for the Batch
   * account.
   * @property {string} [encryption.keySource] Type of the key source. Possible
   * values include: 'Microsoft.Batch', 'Microsoft.KeyVault'
   * @property {object} [encryption.keyVaultProperties] Additional details when
   * using Microsoft.KeyVault
   * @property {string} [encryption.keyVaultProperties.keyIdentifier] Full path
   * to the versioned secret. Example
   * https://mykeyvault.vault.azure.net/keys/testkey/6e34a81fef704045975661e297a4c053
   */
  constructor() {
  }

  /**
   * Defines the metadata of BatchAccountUpdateParameters
   *
   * @returns {object} metadata of BatchAccountUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BatchAccountUpdateParameters',
      type: {
        name: 'Composite',
        className: 'BatchAccountUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          autoStorage: {
            required: false,
            serializedName: 'properties.autoStorage',
            type: {
              name: 'Composite',
              className: 'AutoStorageBaseProperties'
            }
          },
          encryption: {
            required: false,
            serializedName: 'properties.encryption',
            type: {
              name: 'Composite',
              className: 'EncryptionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = BatchAccountUpdateParameters;
