/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information used to connect to a CIFS file system.
  *
 */
class CIFSMountConfiguration {
  /**
   * Create a CIFSMountConfiguration.
   * @property {string} username The user to use for authentication against the
   * CIFS file system.
   * @property {string} source The URI of the file system to mount.
   * @property {string} relativeMountPath The relative path on the compute node
   * where the file system will be mounted. All file systems are mounted
   * relative to the Batch mounts directory, accessible via the
   * AZ_BATCH_NODE_MOUNTS_DIR environment variable.
   * @property {string} [mountOptions] Additional command line options to pass
   * to the mount command. These are 'net use' options in Windows and 'mount'
   * options in Linux.
   * @property {string} password The password to use for authentication against
   * the CIFS file system.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CIFSMountConfiguration
   *
   * @returns {object} metadata of CIFSMountConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CIFSMountConfiguration',
      type: {
        name: 'Composite',
        className: 'CIFSMountConfiguration',
        modelProperties: {
          username: {
            required: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          source: {
            required: true,
            serializedName: 'source',
            type: {
              name: 'String'
            }
          },
          relativeMountPath: {
            required: true,
            serializedName: 'relativeMountPath',
            type: {
              name: 'String'
            }
          },
          mountOptions: {
            required: false,
            serializedName: 'mountOptions',
            type: {
              name: 'String'
            }
          },
          password: {
            required: true,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CIFSMountConfiguration;
