/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a CertificateBaseProperties.
 */
class CertificateBaseProperties {
  /**
   * Create a CertificateBaseProperties.
   * @property {string} [thumbprintAlgorithm] The algorithm of the certificate
   * thumbprint. This must match the first portion of the certificate name.
   * Currently required to be 'SHA1'.
   * @property {string} [thumbprint] The thumbprint of the certificate. This
   * must match the thumbprint from the name.
   * @property {string} [format] The format of the certificate - either Pfx or
   * Cer. If omitted, the default is Pfx. Possible values include: 'Pfx', 'Cer'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateBaseProperties
   *
   * @returns {object} metadata of CertificateBaseProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateBaseProperties',
      type: {
        name: 'Composite',
        className: 'CertificateBaseProperties',
        modelProperties: {
          thumbprintAlgorithm: {
            required: false,
            serializedName: 'thumbprintAlgorithm',
            type: {
              name: 'String'
            }
          },
          thumbprint: {
            required: false,
            serializedName: 'thumbprint',
            type: {
              name: 'String'
            }
          },
          format: {
            required: false,
            nullable: false,
            serializedName: 'format',
            type: {
              name: 'Enum',
              allowedValues: [ 'Pfx', 'Cer' ]
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateBaseProperties;
