/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The configuration for nodes in a pool based on the Azure Cloud
 * Services platform.
  *
 */
class CloudServiceConfiguration {
  /**
   * Create a CloudServiceConfiguration.
   * @property {string} osFamily The Azure Guest OS family to be installed on
   * the virtual machines in the pool. Possible values are: 2 - OS Family 2,
   * equivalent to Windows Server 2008 R2 SP1. 3 - OS Family 3, equivalent to
   * Windows Server 2012. 4 - OS Family 4, equivalent to Windows Server 2012
   * R2. 5 - OS Family 5, equivalent to Windows Server 2016. 6 - OS Family 6,
   * equivalent to Windows Server 2019. For more information, see Azure Guest
   * OS Releases
   * (https://azure.microsoft.com/documentation/articles/cloud-services-guestos-update-matrix/#releases).
   * @property {string} [osVersion] The Azure Guest OS version to be installed
   * on the virtual machines in the pool. The default value is * which
   * specifies the latest operating system version for the specified OS family.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CloudServiceConfiguration
   *
   * @returns {object} metadata of CloudServiceConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudServiceConfiguration',
      type: {
        name: 'Composite',
        className: 'CloudServiceConfiguration',
        modelProperties: {
          osFamily: {
            required: true,
            serializedName: 'osFamily',
            type: {
              name: 'String'
            }
          },
          osVersion: {
            required: false,
            serializedName: 'osVersion',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CloudServiceConfiguration;
