/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The disk encryption configuration applied on compute nodes in the pool. Disk
 * encryption configuration is not supported on Linux pool created with Virtual
 * Machine Image or Shared Image Gallery Image.
 *
 */
class DiskEncryptionConfiguration {
  /**
   * Create a DiskEncryptionConfiguration.
   * @property {array} [targets] The list of disk targets Batch Service will
   * encrypt on the compute node. On Linux pool, only "TemporaryDisk" is
   * supported; on Windows pool, "OsDisk" and "TemporaryDisk" must be
   * specified.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskEncryptionConfiguration
   *
   * @returns {object} metadata of DiskEncryptionConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskEncryptionConfiguration',
      type: {
        name: 'Composite',
        className: 'DiskEncryptionConfiguration',
        modelProperties: {
          targets: {
            required: false,
            serializedName: 'targets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiskEncryptionTargetElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'OsDisk', 'TemporaryDisk' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DiskEncryptionConfiguration;
