/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.AutoStorageBaseProperties = require('./autoStorageBaseProperties');
exports.KeyVaultProperties = require('./keyVaultProperties');
exports.EncryptionProperties = require('./encryptionProperties');
exports.KeyVaultReference = require('./keyVaultReference');
exports.BatchAccountCreateParameters = require('./batchAccountCreateParameters');
exports.AutoStorageProperties = require('./autoStorageProperties');
exports.VirtualMachineFamilyCoreQuota = require('./virtualMachineFamilyCoreQuota');
exports.PrivateEndpoint = require('./privateEndpoint');
exports.PrivateLinkServiceConnectionState = require('./privateLinkServiceConnectionState');
exports.ProxyResource = require('./proxyResource');
exports.PrivateEndpointConnection = require('./privateEndpointConnection');
exports.Resource = require('./resource');
exports.BatchAccount = require('./batchAccount');
exports.BatchAccountUpdateParameters = require('./batchAccountUpdateParameters');
exports.BatchAccountRegenerateKeyParameters = require('./batchAccountRegenerateKeyParameters');
exports.BatchAccountKeys = require('./batchAccountKeys');
exports.ActivateApplicationPackageParameters = require('./activateApplicationPackageParameters');
exports.Application = require('./application');
exports.ApplicationPackage = require('./applicationPackage');
exports.BatchLocationQuota = require('./batchLocationQuota');
exports.CertificateBaseProperties = require('./certificateBaseProperties');
exports.DeleteCertificateError = require('./deleteCertificateError');
exports.Certificate = require('./certificate');
exports.CertificateCreateOrUpdateParameters = require('./certificateCreateOrUpdateParameters');
exports.PrivateLinkResource = require('./privateLinkResource');
exports.CloudServiceConfiguration = require('./cloudServiceConfiguration');
exports.ImageReference = require('./imageReference');
exports.WindowsConfiguration = require('./windowsConfiguration');
exports.DataDisk = require('./dataDisk');
exports.ContainerRegistry = require('./containerRegistry');
exports.ContainerConfiguration = require('./containerConfiguration');
exports.DiskEncryptionConfiguration = require('./diskEncryptionConfiguration');
exports.VirtualMachineConfiguration = require('./virtualMachineConfiguration');
exports.DeploymentConfiguration = require('./deploymentConfiguration');
exports.FixedScaleSettings = require('./fixedScaleSettings');
exports.AutoScaleSettings = require('./autoScaleSettings');
exports.ScaleSettings = require('./scaleSettings');
exports.AutoScaleRunError = require('./autoScaleRunError');
exports.AutoScaleRun = require('./autoScaleRun');
exports.NetworkSecurityGroupRule = require('./networkSecurityGroupRule');
exports.InboundNatPool = require('./inboundNatPool');
exports.PoolEndpointConfiguration = require('./poolEndpointConfiguration');
exports.PublicIPAddressConfiguration = require('./publicIPAddressConfiguration');
exports.NetworkConfiguration = require('./networkConfiguration');
exports.TaskSchedulingPolicy = require('./taskSchedulingPolicy');
exports.LinuxUserConfiguration = require('./linuxUserConfiguration');
exports.WindowsUserConfiguration = require('./windowsUserConfiguration');
exports.UserAccount = require('./userAccount');
exports.MetadataItem = require('./metadataItem');
exports.ResourceFile = require('./resourceFile');
exports.EnvironmentSetting = require('./environmentSetting');
exports.AutoUserSpecification = require('./autoUserSpecification');
exports.UserIdentity = require('./userIdentity');
exports.TaskContainerSettings = require('./taskContainerSettings');
exports.StartTask = require('./startTask');
exports.CertificateReference = require('./certificateReference');
exports.ApplicationPackageReference = require('./applicationPackageReference');
exports.ResizeError = require('./resizeError');
exports.ResizeOperationStatus = require('./resizeOperationStatus');
exports.AzureBlobFileSystemConfiguration = require('./azureBlobFileSystemConfiguration');
exports.NFSMountConfiguration = require('./nFSMountConfiguration');
exports.CIFSMountConfiguration = require('./cIFSMountConfiguration');
exports.AzureFileShareConfiguration = require('./azureFileShareConfiguration');
exports.MountConfiguration = require('./mountConfiguration');
exports.Pool = require('./pool');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.CheckNameAvailabilityParameters = require('./checkNameAvailabilityParameters');
exports.CheckNameAvailabilityResult = require('./checkNameAvailabilityResult');
exports.BatchAccountListResult = require('./batchAccountListResult');
exports.ListApplicationPackagesResult = require('./listApplicationPackagesResult');
exports.ListApplicationsResult = require('./listApplicationsResult');
exports.OperationListResult = require('./operationListResult');
exports.ListCertificatesResult = require('./listCertificatesResult');
exports.ListPrivateLinkResourcesResult = require('./listPrivateLinkResourcesResult');
exports.ListPrivateEndpointConnectionsResult = require('./listPrivateEndpointConnectionsResult');
exports.ListPoolsResult = require('./listPoolsResult');
