/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A REST API operation
  *
 */
class Operation {
  /**
   * Create a Operation.
   * @property {string} [name] The operation name. This is of the format
   * {provider}/{resource}/{operation}
   * @property {object} [display] The object that describes the operation.
   * @property {string} [display.provider]
   * @property {string} [display.operation] For example: read, write, delete,
   * or listKeys/action
   * @property {string} [display.resource]
   * @property {string} [display.description]
   * @property {string} [origin] The intended executor of the operation.
   * @property {object} [properties] Properties of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
