/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Contains information about a private link resource.
 *
 * @extends models['ProxyResource']
 */
class PrivateLinkResource extends models['ProxyResource'] {
  /**
   * Create a PrivateLinkResource.
   * @property {string} [groupId] The group id of the private link resource.
   * The group id is used to establish the private link connection.
   * @property {array} [requiredMembers] The list of required members that are
   * used to establish the private link connection.
   * @property {array} [requiredZoneNames] The list of required zone names for
   * the private DNS resource name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PrivateLinkResource
   *
   * @returns {object} metadata of PrivateLinkResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateLinkResource',
      type: {
        name: 'Composite',
        className: 'PrivateLinkResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          groupId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.groupId',
            type: {
              name: 'String'
            }
          },
          requiredMembers: {
            required: false,
            readOnly: true,
            serializedName: 'properties.requiredMembers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          requiredZoneNames: {
            required: false,
            readOnly: true,
            serializedName: 'properties.requiredZoneNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateLinkResource;
