/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The private link service connection state of the private endpoint connection
 *
 */
class PrivateLinkServiceConnectionState {
  /**
   * Create a PrivateLinkServiceConnectionState.
   * @property {string} status The status for the private endpoint connection
   * of Batch account. Possible values include: 'Approved', 'Pending',
   * 'Rejected', 'Disconnected'
   * @property {string} [description] Description of the private Connection
   * state.
   * @property {string} [actionRequired] Action required on the private
   * connection state.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrivateLinkServiceConnectionState
   *
   * @returns {object} metadata of PrivateLinkServiceConnectionState
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateLinkServiceConnectionState',
      type: {
        name: 'Composite',
        className: 'PrivateLinkServiceConnectionState',
        modelProperties: {
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Approved', 'Pending', 'Rejected', 'Disconnected' ]
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          actionRequired: {
            required: false,
            readOnly: true,
            serializedName: 'actionRequired',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateLinkServiceConnectionState;
