/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A definition of an Azure resource.
 *
 * @extends models['BaseResource']
 */
class ProxyResource extends models['BaseResource'] {
  /**
   * Create a ProxyResource.
   * @property {string} [id] The ID of the resource.
   * @property {string} [name] The name of the resource.
   * @property {string} [type] The type of the resource.
   * @property {string} [etag] The ETag of the resource, used for concurrency
   * statements.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProxyResource
   *
   * @returns {object} metadata of ProxyResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProxyResource',
      type: {
        name: 'Composite',
        className: 'ProxyResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            readOnly: true,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProxyResource;
