/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A VM Family and its associated core quota for the Batch account.
 *
 */
class VirtualMachineFamilyCoreQuota {
  /**
   * Create a VirtualMachineFamilyCoreQuota.
   * @property {string} [name] The Virtual Machine family name.
   * @property {number} [coreQuota] The core quota for the VM family for the
   * Batch account.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineFamilyCoreQuota
   *
   * @returns {object} metadata of VirtualMachineFamilyCoreQuota
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineFamilyCoreQuota',
      type: {
        name: 'Composite',
        className: 'VirtualMachineFamilyCoreQuota',
        modelProperties: {
          name: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          coreQuota: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'coreQuota',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineFamilyCoreQuota;
