/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Properties used to create a user account on a Windows node.
  *
 */
class WindowsUserConfiguration {
  /**
   * Create a WindowsUserConfiguration.
   * @property {string} [loginMode] Login mode for user. Specifies login mode
   * for the user. The default value for VirtualMachineConfiguration pools is
   * interactive mode and for CloudServiceConfiguration pools is batch mode.
   * Possible values include: 'Batch', 'Interactive'
   */
  constructor() {
  }

  /**
   * Defines the metadata of WindowsUserConfiguration
   *
   * @returns {object} metadata of WindowsUserConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WindowsUserConfiguration',
      type: {
        name: 'Composite',
        className: 'WindowsUserConfiguration',
        modelProperties: {
          loginMode: {
            required: false,
            serializedName: 'loginMode',
            type: {
              name: 'Enum',
              allowedValues: [ 'Batch', 'Interactive' ]
            }
          }
        }
      }
    };
  }
}

module.exports = WindowsUserConfiguration;
